;; The first three lines of this file were inserted by DrRacket. They record metadata
;; about the language level of this file in a form that our tools can easily process.
#reader(lib "htdp-beginner-reader.ss" "lang")((modname bad-robot) (read-case-sensitive #t) (teachpacks ()) (htdp-settings #(#t constructor repeating-decimal #f #t none #f ())))
(require rackunit)
(require rackunit/text-ui)
(require "extras.rkt")

(provide
  initial-robot
  robot-left 
  robot-right
  robot-forward
  robot-north? 
  robot-south? 
  robot-east? 
  robot-west?)

(define RADIUS 15)
(define-struct robot(p1 p2 d))
;the robot is 
;...
;(make-robot x y dir)
;interp:
;x is the x coordinate of the robot center.
;y is the y coordinate of the robot cener.
;d gives the direction of the robot.
;robot-fn : robot->??
;TEMPLATE
(define (robot-fn r)
  (...
   (robot-p1 r)
   (robot-p2 r)
   (robot-d r)))

;initial-robot : PosInt PosInt -> Robot
;GIVEN: a set of (x,y) coordinates
;RETURNS: a robot with its center at those coordinates, facing north
;(up)
;examples:
;(initial-robot 100 200) = (make-robot 100 200 "north")
;(initial-robot 120 135) = (make-robot 120 135 "north")
;strategy: call simpler function

;function definition
(define (initial-robot p1 p2)
  (make-robot  p1 p2 "north"))

;Tests:
(begin-for-test
  (check-equal?
   (initial-robot 100 150)
   (make-robot 100 150 "north")
   "initial state of the robot"))


;robot-left : Robot -> Robot
;GIVEN: a robot
;RETURNS: a robot like the original, but turned 90 degrees left
;examples:
;(robot-left (make-robot 100 150 "west")) = (make-robot 100 150 "south")
;(robot-left (make-robot 140 200 "north")) = (make-robot 140 200 "west")
;strategy: Use template for Robot on r

;function definition
(define (robot-left l)
  (cond
    [(string=? (robot-d l)  "north" )
     (make-robot (robot-p1 l) (robot-p2 l) "west")]
    [(string=? (robot-d l)  "south")
     (make-robot (robot-p1 l) (robot-p2 l) "east")] 
    [(string=? (robot-d l)  "west")
     (make-robot (robot-p1 l) (robot-p2 l) "south")]
    [(string=? (robot-d l)  "east")
     (make-robot (robot-p1 l) (robot-p2 l) "north")]))

;Tests
(begin-for-test
  (check-equal?
   (robot-left (make-robot 100 200 "north"))
   (make-robot 100 200 "west")
   "left of north is west")

  (check-equal?
   (robot-left (make-robot 100 200 "east"))
   (make-robot 100 200 "north")
   "left of east is north")

  (check-equal?
   (robot-left (make-robot 100 200 "west"))
   (make-robot 100 200 "south")
   "left of west is south")

  (check-equal?
   (robot-left (make-robot 100 200 "south"))
   (make-robot 100 200 "east")
   "left of south is east"))
  

;robot-right : Robot -> Robot
;GIVEN: a robot
;RETURNS: a robot like the original, but turned 90 degrees either right
;examples:
;(robot-right (make-robot 100 150 "west")) = (make-robot 100 150 "north")
;(robot-right (make-robot 140 200 "north")) = (make-robot 140 200 "east")
;strategy: Use template for Robot

;function definition
(define (robot-right r)
  (cond
    [(string=? (robot-d r) "north") 
     (make-robot (robot-p1 r) (robot-p2 r) "east")]
    [(string=? (robot-d r) "south") 
     (make-robot (robot-p1 r) (robot-p2 r) "west")]
    [(string=? (robot-d r) "east") 
     (make-robot (robot-p1 r) (robot-p2 r) "south")]
    [(string=? (robot-d r) "west") 
     (make-robot (robot-p1 r) (robot-p2 r) "north")]))

;Tests
(begin-for-test
  (check-equal?
   (robot-right (make-robot 100 200 "north"))
   (make-robot 100 200 "east")
   "left of north is west")

  (check-equal?
   (robot-right (make-robot 100 200 "east"))
   (make-robot 100 200 "south")
   "left of east is north")

  (check-equal?
   (robot-right (make-robot 100 200 "west"))
   (make-robot 100 200 "north")
   "left of west is south")

  (check-equal?
   (robot-right (make-robot 100 200 "south"))
   (make-robot 100 200 "west")
   "left of south is east"))
  

;check-boundary-wall?: Robot Distance -> Boolean
;GIVEN: A robot and distance to be moved forward
;RETURNS: true if the robot is inside the boundary of the wall
;examples:
;(check-boundary-wall? (make-robot -10 20 "north") 10) = true
;(check-boundary-wall? (make-robot -10 -20 "east") 15) = true
;(check-boundary-wall? (make-robot 10 20 "south") 20) = false
;Strategy: Use template for Robot

;function definition
(define (check-boundary-wall? robo D)
  (cond
    [ (or (and (<= (robot-p1 robo) 15) (<= (robot-p2 robo) 15)) 
          (and (>= (robot-p1 robo) 185) (>= (robot-p2 robo) 385)) 
          (and (>= (robot-p1 robo) 185) (<= (robot-p2 robo) 385)) 
          (and (<= (robot-p1 robo) 185) (>= (robot-p2 robo) 385))
          (and (>= (robot-p1 robo) 15) (<= (robot-p2 robo) 15)) 
          (and (<= (robot-p1 robo) 185) (<= (robot-p2 robo) 15))
          (and (>= (robot-p1 robo) 15) (>= (robot-p2 robo) 385)) 
          (and (<= (robot-p1 robo) 15) (<= (robot-p2 robo) 385)) 
          (and (>= (robot-p1 robo) 0) (<= (robot-p2 robo) 15)))    
      true]
    [else false]))

;Tests:
(begin-for-test
  (check-equal?
   (check-boundary-wall?(make-robot -100 -200 "north") 100)
   true
   "It is outside the canvass")
  
  (check-equal?
   (check-boundary-wall?(make-robot 210 400 "south") 100)
   true
   "It is outside the canvass")
  
  (check-equal?
   (check-boundary-wall?(make-robot 220 -200 "north") 100)
   true
   "It is outside the canvass")
  
  (check-equal?
   (check-boundary-wall?(make-robot -100 600 "north") 100)
   true
   "It is outside the canvass")
  
  (check-equal?
   (check-boundary-wall?(make-robot 100 -200 "north") 100)
   true
   "It is outside the canvass")
  
  (check-equal?
   (check-boundary-wall?(make-robot -100 200 "north") 100)
   true
   "It is outside the canvass")
  
  (check-equal?
   (check-boundary-wall?(make-robot 190 10 "south") 10)
   true
   "It is outside the canvass")
  
  (check-equal?
   (check-boundary-wall?(make-robot 10 399 "south") 10)
   true
   "It is outside the canvass")
  
  (check-equal?
   (check-boundary-wall?(make-robot 10 40 "south") 10)
   true
   "It is outside the canvass")
  
  (check-equal?
   (check-boundary-wall?(make-robot 100 130 "north") 100)
   false
   "It is inside the canvass"))
  
 
;check-north: Robot Distance -> Robot
;GIVEN: robot and distance
;RETURNS: robot at a new position
;examples:
;(check-north (make-robot 10 -20 "north") 15)=
;(make-robot 10 -35 "north")
;(check-north (make-robot 10 40 "north") 10)=
;(northins (make-robot 10 40 "north") 10)
;strategy: Use template for Robot

;function definition
(define (check-north RR DD)
  (if (or (< (robot-p2 RR) 15) (< (robot-p1 RR) 15))
      (make-robot (robot-p1 RR) (- (robot-p2 RR) DD) (robot-d RR))
      (northins RR DD)))

;northins: Robot Distance -> Robot
;GIVEN: robot and distance
;RETURNS: robot at a new position
;examples:
;(northins (make-robot 10 15 "north") 10) =
;(make-robot 10 15 "north")
;(northins (make-robot 10 50 "north") 10) =
;(make-robot 10 40 "north")
;strategy: Use template for Robot

;function definition
(define (northins ron dtn)  
  (cond
    [(>= (robot-p1 ron) 15) (north ron dtn)]))

;north: Robot Distance -> Robot
;GIVEN: a robot and distance 
;RETURNS: robot at new position
;examples:
;(north (make-robot 100 20 "north") 10) =
;(make-robot 100 15 "north")
;(north (make-robot 100 50 "north") 10) =
;(make-robot 100 40 "north")
;strategy: Use template for Robot

;function definition
(define (north rnn dnn)
  (if (<= (- (robot-p2 rnn) dnn) 15)
      (make-robot (robot-p1 rnn) 15 (robot-d rnn))
      (make-robot (robot-p1 rnn) (- (robot-p2 rnn) dnn) (robot-d rnn))))

;Tests:
(begin-for-test
  (check-equal?
   (check-north (make-robot 120 420 "north") 40)
   (make-robot 120 380 "north")
   "new position of robot")

 (check-equal?
   (check-north (make-robot 120 20 "north") 10)
   (make-robot 120 15 "north")
   "new position of robot at wall")

 (check-equal?
  (check-north (make-robot 20 -100 "north") 10)
  (make-robot 20 -110 "north")
  "new position of robot")
  
  (check-equal?
  (check-north (make-robot -100 -100 "north") 10)
  (make-robot -100 -110 "north")
  "new position of robot")
  
  (check-equal?
  (check-north (make-robot 100 30 "north") 10)
  (make-robot 100 20 "north")
  "new position of robot"))
  
  
;check-south: Robot Distance -> Robot
;GIVEN: robot and distance
;RETURNS:robot at a new position
;examples:
;(check-south (make-robot 100 450 "south") 10) =
;(make-robot 100 460 "south")
;(check-south (make-robot 100 250 "south") 10) =
;(southins (make-robot 100 250 "south") 10)
;strategy: structural decomposition on robot

;function definition
(define (check-south RS DDS)
  (if (> (robot-p2 RS) 385)
      (make-robot (robot-p1 RS) (+ (robot-p2 RS) DDS) (robot-d RS))
      (southins RS DDS)))

;southins: Robot Distance -> Robot
;GIVEN: robot and distance
;RETURNS:robot at a new position
;examples:
;(southins (make-robot 100 250 "south") 10) =
;(make-robot 100 260 "south")
;(southins (make-robot 100 380 "south") 10) =
;(make-robot 100 385 "south")
;strategy: Use template for Robot

;function definition
(define (southins robs dss)
  (if (or (and (< (robot-p2 robs) 15) (< (robot-p1 robs) 15))
          (> (robot-p1 robs) 185))
      (make-robot (robot-p1 robs) (+ (robot-p2 robs) dss) (robot-d robs))
      (south robs dss)))

;south: Robot Distance -> Robot
;GIVEN: robot and distance
;RETURNS:robot at a new position
;examples:
;(south (make-robot 10 380 "south") 10) =
;(make-robot 10 385 "south")
;(south (make-robot 20 40 "south") 10) =
;(make-robot 20 50 "south")
;strategy: Use template for Robot

;function definition
(define (south robos dis-s) 
  (if (>= (+ (robot-p2 robos) dis-s) 385)
      (make-robot (robot-p1 robos) 385 (robot-d robos))
      (make-robot (robot-p1 robos) (+ (robot-p2 robos) dis-s) (robot-d robos))))

;Tests
(begin-for-test
  (check-equal?
   (check-south (make-robot 120 -120 "south") 40)
   (make-robot 120 -80 "south")
   "new position of robot")
  
  (check-equal?
   (check-south (make-robot 120 380 "south") 10)
   (make-robot 120 385 "south")
   "new position of robot")
  
  (check-equal?
   (check-south (make-robot 100 450 "south") 10)
   (make-robot 100 460 "south")
   "new position of robot")
  
  (check-equal?
   (check-south (make-robot -100 -450 "south") 10)
   (make-robot -100 -440 "south")
   "new position of robot"))


;check-east: Robot Distance -> Robot
;GIVEN: robot and distance
;RETURNS:robot at a new position
;examples:
;(check-east (make-robot 230 30 "east") 10) =
;(make-robot 240 30 "east")
;(check-east (make-robot 100 30 "east") 10) =
;(eastins (make-robot 100 30 "east") 10)
;strategy: structural decomposition on robot

;function definition
(define (check-east RE DDE)
  (if (or (< (robot-p2 RE) 15) (> (robot-p2 RE) 385))
      (make-robot (+ (robot-p1 RE) DDE) (robot-p2 RE) (robot-d RE))
      (eastins RE DDE)))

;eastins: Robot Distance -> Robot
;GIVEN: robot and distance
;RETURNS:robot at a new position
;examples:
;(eastins (make-robot 145 50 "east") 10) =
;(make-robot 155 50 "east")
;(eastins (make-robot 180 50 "east") 10) =
;(make-robot 185 50 "east")
;strategy: Use template for Robot

;function definition
(define (eastins roe dte)
  (if
    (and (>= (robot-p2 roe) 15) (>= (robot-p1 roe) 185))
    (make-robot (+ (robot-p1 roe) dte) (robot-p2 roe) (robot-d roe))
    (east roe dte)))

;east: Robot Distance -> Robot
;GIVEN: robot and distance
;RETURNS:robot at a new position
;examples:
;(east (make-robot 180 20 "east") 10) =
;(make-robot 185 20 "east")
;(east (make-robot 150 50 "east") 10) =
;(make-robot 160 50 "east")
;strategy: Use template for Robot

;function definition
(define (east rrr ddd)
  (if (>= (+ (robot-p1 rrr) ddd) 185)
      (make-robot 185 (robot-p2 rrr) (robot-d rrr))
      (make-robot (+ (robot-p1 rrr) ddd) (robot-p2 rrr) (robot-d rrr))))

;Tests
(begin-for-test

  (check-equal?
   (check-east (make-robot -120 40 "east") 40)
   (make-robot -80 40 "east")
   "new position of robot")
  
  (check-equal?
   (check-east (make-robot 180 380 "east") 10)
   (make-robot 185 380 "east")
   "new position of robot")
  
  (check-equal?
  (check-east (make-robot 240 30 "east") 40)
  (make-robot 280 30 "east")
  "new position of robot"))


;check-west: robot distance ->robot
;GIVEN: robot and distance
;RETURNS:robot at a new position
;examples:
;(check-west (make-robot -10 50 "west") 10) =
;(make-robot -20 50 "west")
;(check-west (make-robot 20 50 "west") 10) =
;(westins (make-robot 20 50 "west") 10)
;strategy: Use template for Robot

;function definition
(define (check-west RW DDW)
  (if (or (< (robot-p1 RW) 15) (> (robot-p2 RW) 385) (< (robot-p2 RW) 15))
      (make-robot (- (robot-p1 RW) DDW) (robot-p2 RW) (robot-d RW))
      (westins RW DDW)))

;westins: robot distance ->robot
;GIVEN: robot and distance
;RETURNS:robot at a new position
;examples:
;(westins (make-robot 100 20 "west") 10) =
;(make-robot 90 20 "west")
;(westins (make-robot 25 20 "west") 20) =
;(make-robot 15 20 "west")
;strategy: Use template for Robot

;function definition
(define (westins robw dww)
  (cond
    [(>= (robot-p2 robw) 15) (west robw dww)]))

;westins: robot distance ->robot
;GIVEN: robot and distance
;RETURNS:robot at a new position
;examples:
;(westins (make-robot 100 20 "west") 10) =
;(make-robot 90 20 "west")
;(westins (make-robot 25 20 "west") 20) =
;(make-robot 15 20 "west")
;strategy: Use template for Robot

;function definition
(define (west rww ddw)
  (if (<= (- (robot-p1 rww) ddw) 15)
      (make-robot 15 (robot-p2 rww) (robot-d rww))
      (make-robot (- (robot-p1 rww) ddw) (robot-p2 rww) (robot-d rww))))
         
;Tests
(begin-for-test
  (check-equal?
   (check-west (make-robot 120 421 "west") 40)
   (make-robot 80 421 "west")
   "robot is towards west")
  
  (check-equal?
   (check-west (make-robot 20 380 "west") 10)
   (make-robot 15 380 "west")
   "robot is towards west")
  
  (check-equal?
   (check-west (make-robot -20 380 "west") 10)
   (make-robot -30 380 "west")
   "robot is towards west")
  
  (check-equal?
   (check-west (make-robot 20 350 "west") 10)
   (make-robot 15 350 "west")
   "robot is towards west")
  
  (check-equal?
   (check-west (make-robot -20 -5 "west") 200)
   (make-robot  -220 -5 "west")
   "robot is towards west")
  
 (check-equal?
   (check-west (make-robot 14 385 "west") 10)
   (make-robot 4 385 "west")
   "robot is towards west")
  
  (check-equal?
   (check-west (make-robot 40 350 "west") 10)
   (make-robot 30 350 "west")
   "robot is towards west"))


;check-direction: Robot distance -> Robot
;GIVEN: robot and distance 
;RETURNS: robot at the new position
;examples:
;(check-direction (make-robot 100 50 "north") 10) =
;(check-north (make-robot 100 50 "north") 10)
;(check-direction (make-robot 100 50 "south") 10) =
;(check-south (make-robot 100 50 "south") 10)
;(check-direction (make-robot 100 50 "east") 10) =
;(check-east (make-robot 100 50 "east") 10)
;(check-direction (make-robot 100 50 "west") 10) =
;(check-west (make-robot 100 50 "west") 10)
; STRATEGY: Use template for Robot

;function definition
(define (check-direction rob distance)
  (cond
    [(string=? (robot-d rob) "north") (check-north rob distance)]
    [(string=? (robot-d rob) "south") (check-south rob distance)]
    [(string=? (robot-d rob) "east")  (check-east rob distance)]
    [(string=? (robot-d rob) "west") (check-west rob distance)]))

;Tests
(begin-for-test
  (check-equal?
   (check-direction (make-robot 120 -140 "north") 100) 
   (check-north(make-robot 120 -140 "north") 100))
  
 (check-equal?
   (check-direction (make-robot 120 -140 "south") 100)
   (check-south(make-robot 120 -140 "south") 100))
   
  (check-equal?
   (check-direction (make-robot 120 -140 "east") 100)
   (check-east(make-robot 120 -140 "east") 100))
  
  (check-equal?
   (check-direction (make-robot 120 -140 "west") 100) 
   (check-west(make-robot 120 -140 "west") 100)))


;north-side: robot distance -> robot
;GIVEN: a robot and distance
;RETURNS: a robot position 
;examples:
;(north-side (make-robot 40 60 "north") 10) =
;(make-robot 30 60 "north")
;strategy: structural decomposition on robot

;function definition
(define (north-side RNS RDI)
  (if (>= (- (robot-p2 RNS) RADIUS RDI) 0)
      (make-robot (robot-p1 RNS) (- (robot-p2 RNS) RDI) (robot-d RNS))
      (make-robot (robot-p1 RNS) 15 (robot-d RNS))))

;south-side: robot distance -> robot
;GIVEN: a robot and distance
;RETURNS: a robot position 
;examples:
;(south-side (make-robot 40 60 "south") 10) =
;(make-robot 
;STRATEGY: Use template for Robot

;function definition
(define (south-side RSS DI)
  (if (<= (+ (robot-p2 RSS) RADIUS DI) 400)
      (make-robot (robot-p1 RSS) (+ (robot-p2 RSS) DI) (robot-d RSS))
      (make-robot (robot-p1 RSS) 385 (robot-d RSS))))

;east-side: robot distance -> robot
;GIVEN: a robot and distance
;RETURNS: a robot position 
;examples:
;(east-side (make-robot 40 60 "east") 10) =
;(make-robot 50 60 "east")
;STRATEGY: Use template for Robot

;function definition
(define (east-side RES DII)
  (if (<= (+ (robot-p1 RES) RADIUS DII) 200)
      (make-robot (+ (robot-p1 RES) DII) (robot-p2 RES) (robot-d RES))
      (make-robot 185 (robot-p2 RES) (robot-d RES))))


;west-side: robot distance -> robot
;GIVEN: a robot and distance
;RETURNS: a robot position 
;examples:
;(west-side (make-robot 30 40 "west") 10) =
; (make-robot 20 40 "west")
;STRATEGY: Use template for Robot

;fucntion definition
(define (west-side RWS DD)
  (if (>= (- (robot-p1 RWS) RADIUS DD) 0)
      (make-robot (- (robot-p1 RWS) DD) (robot-p2 RWS) (robot-d RWS))
      (make-robot 15 (robot-p2 RWS) (robot-d RWS))))
  

;reached-boundary: Robot distance -> robot
;GIVEN: a robot and distance
;RETURNS: a robot at the boundary walls
;examples:
;(reached-boundary (make-robot 100 140 "north") 10)
;(make-robot 100 130 "north")
;(reached-boundary (make-robot 100 50 "north") 40)
;(north-side(make-robot 100 50 "north") 40)
;STRATEGY: Use template for Robot

;fucntion definition
(define (reached-boundary rt di)
  (cond
    [(string=? (robot-d rt) "north") (north-side rt di)]
    [(string=? (robot-d rt) "south") (south-side rt di)]
    [(string=? (robot-d rt) "east") (east-side rt di)]
    [(string=? (robot-d rt) "west") (west-side rt di)]))

;Tests
(begin-for-test
  (check-equal? 
   (reached-boundary (make-robot 100 140 "north") 10)
   (make-robot 100 130 "north")
   "robot is towards north")
  
  (check-equal? 
   (reached-boundary (make-robot 100 50 "north") 40)
   (north-side(make-robot 100 50 "north") 40)
   "robot is towards north")
  
  (check-equal? 
   (reached-boundary (make-robot 100 140 "south") 10)
   (south-side(make-robot 100 140 "south") 10)
   "robot is towards south")
  
  (check-equal? 
   (reached-boundary (make-robot 100 380 "south") 25)
   (south-side(make-robot 100 380 "south") 25)
   "robot is towards south")
  
  (check-equal? 
   (reached-boundary (make-robot 100 140 "east") 10)
   (east-side(make-robot 100 140 "east") 10)
   "robot is towards east")
  
  (check-equal? 
   (reached-boundary (make-robot 180 140 "east") 20)
   (east-side(make-robot 180 140 "east") 20)
   "robot is towards east")
  
  (check-equal? 
   (reached-boundary (make-robot 100 140 "west") 10)
   (west-side(make-robot 100 140 "west") 10)
   "robot is towards west")
  
  (check-equal? 
   (reached-boundary (make-robot 20 140 "west") 10)
   (west-side(make-robot 20 140 "west") 10)
   "robot is towards west"))


;robot-forward : Robot PosInt -> Robot
;GIVEN: a robot and a distance
;RETURNS: a robot like the given one, but moved forward by the
;specified number of pixels.  If moving forward the specified number of
;pixels would cause the robot to move from being entirely inside the 
;canvas to being even partially outside the canvas,then the robot
;should stop at the wall.
;examples:
;(robot-forward(make-robot -100 -200 "north") 100) =
;(make-robot -100 -300 "north")
;(robot-forward(make-robot 100 20 "north") 10) =
;(make-robot 100 15 "north")
;STRATEGY: Use template for Robot

;function definition
(define (robot-forward rf dist)
  (if
    (check-boundary-wall? rf dist) (check-direction rf dist) 
    (reached-boundary rf dist)))

;Tests:
(begin-for-test
  (check-equal?
   (robot-forward(make-robot -100 -200 "north") 100)
   (make-robot -100 -300 "north")
   "robot is outside the canvass")
   
  (check-equal?
   (robot-forward(make-robot 100 20 "north") 10)
   (make-robot 100 15 "north")
   "robot is at the wall")
  
  (check-equal?
   (robot-forward(make-robot -100 50 "north") 3)
  (make-robot -100 47 "north")
  "robot is outside the canvass")
  
  (check-equal?
   (robot-forward(make-robot 100 -20 "north") 10)
   (make-robot 100 -30 "north")
   "robot is outside the wall"))

  
;robot-north? : Robot -> Boolean
;GIVEN: a robot
;ANSWERS: whether the robot is facing in the specified direction.
;examples:
;(robot-north?(make-robot 156 345 "north")) = true
;(robot-north?(make-robot 156 345 "south")) = false
;(robot-north?(make-robot 156 345 "west")) = false
;(robot-north?(make-robot 156 345 "east")) = false
;STRATEGY: Use template for Robot

;function definition
(define (robot-north? rn)
  (cond
   [(string=? (robot-d rn) "north") true]
   [else false]))

;Tests
(begin-for-test
  (check-equal?
   (robot-north?(make-robot 100 200 "north"))
   true
   "if robot is facing north then returns true")
  
  (check-equal?
   (robot-north?(make-robot 100 200 "south"))
   false
   "if robot is not facing north then returns false")
  
  (check-equal?
   (robot-north?(make-robot 100 200 "west"))
   false
   "if robot is not facing north then returns false")
  
  (check-equal?
   (robot-north?(make-robot 100 200 "east"))
   false
   "if robot is not facing north then returns false"))


;robot-south? : Robot -> Boolean
;GIVEN: a robot
;ANSWERS: whether the robot is facing in the specified direction.
;examples:
;(robot-north?(make-robot 106 345 "north")) = false
;(robot-north?(make-robot 116 145 "south")) = true
;(robot-north?(make-robot 151 345 "west")) = false
;(robot-north?(make-robot 156 115 "east")) = false
;STRATEGY: Use template for Robot

;function definition
(define (robot-south? rs)
  (cond
    [(string=? (robot-d rs) "south") true]
    [else false]))

;Tests
(begin-for-test
  (check-equal?
   (robot-south?(make-robot 101 220 "south"))
   true
   "if robot is facing south then returns true")
  
  (check-equal?
   (robot-south?(make-robot 120 222 "north"))
   false
   "if robot is not facing south then returns false")
  
  (check-equal?
   (robot-south?(make-robot 159 134 "west"))
   false
   "if robot is not facing south then returns false")
  
  (check-equal?
   (robot-south?(make-robot 100 200 "east"))
   false
   "if robot is not facing south then returns false"))


;robot-east? : Robot -> Boolean
;GIVEN: a robot
;ANSWERS: whether the root is facing in the specified direction.
;examples:
;(robot-east?(make-robot 106 345 "east")) = true
;(robot-east?(make-robot 116 145 "north")) = false
;(robot-east?(make-robot 151 345 "west")) = false
;(robot-east?(make-robot 156 115 "south")) = false
;STRATEGY: Use template for Robot

;function definition
(define (robot-east? re)
  (cond
    [(string=? (robot-d re) "east") true]
    [else false]))

;Tests
(begin-for-test
  (check-equal?
   (robot-east?(make-robot 101 220 "east"))
   true
   "if robot is facing east then returns true")
  
  (check-equal?
   (robot-east?(make-robot 120 222 "north"))
   false
   "if robot is not facing east then returns false")
  
  (check-equal?
   (robot-east?(make-robot 159 134 "west"))
   false
   "if robot is not facing east then returns false")
  
  (check-equal?
   (robot-east?(make-robot 100 200 "south"))
   false
   "if robot is not facing east then returns false"))


;robot-west? : Robot -> Boolean
;GIVEN: a robot
;ANSWERS: whether the root is facing in the specified direction.
;examples:
;(robot-west?(make-robot 106 345 "west")) = true
;(robot-west?(make-robot 116 145 "north")) = false
;(robot-west?(make-robot 151 345 "west")) = false
;(robot-west?(make-robot 156 115 "south")) = false
;STRATEGY: Use template for Robot

;function definition
(define (robot-west? rw)
  (cond
    [(string=? (robot-d rw) "west") true]
    [else false]))   

;Tests
(begin-for-test
  (check-equal?
   (robot-west?(make-robot 101 220 "west"))
   true
   "if robot is facing west then returns true")
  
  (check-equal?
   (robot-west?(make-robot 120 222 "north"))
   false
   "if robot is not facing west then returns false")
  
  (check-equal?
   (robot-west?(make-robot 159 134 "south"))
   false
   "if robot is not facing west then returns false")
  
  (check-equal?
   (robot-west?(make-robot 100 200 "east"))
   false
   "if robot is not facing west then returns false"))

